//Global options

options.defaultValue("W")=9;
options.defaultValue("H")=9;
options.defaultValue("IFILL")=25;
options.defaultValue("LOOP_CHANCE")=50;
options.defaultValue("DOUBLE_CHANCE")=50;

//Global variables

//W;H;IFILL;LOOP_CHANCE;DOUBLE_CHANCE;ALLOW_LOOPS;

max_fails=500;

block_input=true;
board=null;
cur_board=null;
islands=null;
cur_island=0;
max_islands=0;
buttons=new Array(25);

//Main functions

function initializeVariables(){
    for (i=0;i<25;i++){
        buttons[i]=new Array(25);
        for (j=0;j<25;j++) buttons[i][j]=appendElement('<button image="" overImage="" downImage="" width="16" height="16" x="'+(i*16)+'" y="'+(j*16)+'" onclick="buttonClick('+i+','+j+')"/>');
    }
}
function newGame(){
    block_input=true;
		W=options("W");
		H=options("H");
		IFILL=options("IFILL");
		LOOP_CHANCE=options("LOOP_CHANCE");
		DOUBLE_CHANCE=options("DOUBLE_CHANCE");
		ALLOW_LOOPS=(LOOP_CHANCE==0?false:true);
    var maxx;
    var maxy;
    width=16*W;
    height=16*H+28;
    solve.x=width-58;
    solve.y=height-20;
    rules.y=height-18;
    max_islands=Math.ceil(W*H*IFILL/100);
    cur_island=0;
    board=new Array(W);
    cur_board=new Array(W);
    islands=new Array(max_islands);
    for (var i=0;i<W;i++){
	    board[i]=new Array(H);
	    cur_board[i]=new Array(H);
	    for (var j=0;j<H;j++) board[i][j]=cur_board[i][j]=0;
    }
    i=Math.floor(Math.random()*W);
    j=Math.floor(Math.random()*H);
    board[i][j]=1;
    islands[cur_island]=i*H+j;
    cur_island++;
    while (cur_island<max_islands){
        var st=false;
        var cur_fails=0;
        while (!st && cur_fails<max_fails){
            var can_connect=false;
            var x=islands[Math.floor(Math.random()*cur_island)];
            var y=x%H;
            x=Math.floor(x/H);
            st=false;
            var dir=Math.floor(Math.random()*4);
            var pasx=(dir==0?0:dir==1?1:dir==2?0:-1);
            var pasy=(dir==0?-1:dir==1?0:dir==2?1:0);
            var minx=x+pasx+pasx;
            var miny=y+pasy+pasy;
            if (minx<0 || miny<0 || minx>=W || miny>=H || board[minx][miny]!=0 || board[minx-pasx][miny-pasy]!=0) cur_fails++;
            else{
                for (maxx=minx,maxy=miny;!st && maxx<W && maxy<H && maxx>=0 && maxy>=0;maxx+=pasx,maxy+=pasy){
                    if (board[maxx][maxy]!=0){
                        st=true;
                        if (board[maxx][maxy]==1) can_connect=true;
                    }
                }
                maxx-=pasx;maxy-=pasy;
                if (st) {
                    st=false;
                    if (!can_connect) {maxx-=pasx;maxy-=pasy;}
                }
                if (can_connect){
                    if (ALLOW_LOOPS && Math.floor(Math.random()*100)<LOOP_CHANCE){
                        for (i=x+pasx,j=y+pasy;i!=maxx || j!=maxy;i+=pasx,j+=pasy) board[i][j]=((dir==0 || dir==2)?21:11);
                        cur_island--;
                        st=true;
                    }else{
                        maxx-=pasx+pasx;
                        maxy-=pasy+pasy;
                    }
                }else if (maxx*pasx<minx*pasx || maxy*pasy<miny*pasy) cur_fails++;
                else{
                    maxx=minx+pasx*Math.floor(Math.random()*(Math.abs(maxx-minx)+1));
                    maxy=miny+pasy*Math.floor(Math.random()*(Math.abs(maxy-miny)+1));
                    if ((maxx+pasy>=0 && maxx+pasy<W && maxy+pasx>=0 && maxy+pasx<H && board[maxx+pasy][maxy+pasx]==1) || (maxx-pasy>=0 && maxx-pasy<W && maxy-pasx>=0 && maxy-pasx<H && board[maxx-pasy][maxy-pasx]==1)) cur_fails++;
                    else{
                        for (i=x+pasx,j=y+pasy;i!=maxx || j!=maxy;i+=pasx,j+=pasy) board[i][j]=((dir==0 || dir==2)?21:11);
                        board[maxx][maxy]=1;
                        islands[cur_island]=maxx*H+maxy;
                        st=true;
                    }
                }
            }
        }
        if (cur_fails>=max_fails) max_islands=cur_island; else cur_island++;
    }
    var amsus=false;
    var amjos=false;
    var amst=false;
    var amdr=false;
    for (i=0;i<max_islands && !(amsus && amjos && amst && amdr);i++){
        x=Math.floor(islands[i]/H);
        y=islands[i]%H;
        if (x==0) amst=true;
        if (x==W-1) amdr=true;
        if (y==0) amsus=true;
        if (y==H-1) amjos=true;
        
    }
    if (!(amsus && amjos && amst && amdr)) newGame();
    else{
        for (i=0;i<max_islands;i++){
            x=Math.floor(islands[i]/H);
            y=islands[i]%H;
            j=0;
            for (dir=0;dir<4;dir++){
                pasx=(dir==0?0:dir==1?1:dir==2?0:-1);
                pasy=(dir==0?-1:dir==1?0:dir==2?1:0);
                minx=x+pasx;miny=y+pasy;
                if (minx>=0 && minx<W && miny>=0 && miny<H && board[minx][miny]>10){
                    if ((board[minx][miny]<20 && dir%2==1) || (board[minx][miny]>20 && dir%2==0)){
                        j++;
                        if (board[minx][miny]==12 || board[minx][miny]==22) j++;
                        else if (Math.floor(Math.random()*200)<DOUBLE_CHANCE){
                            j++;
                            while(board[minx][miny]>10){
                                board[minx][miny]++;
                                minx+=pasx;miny+=pasy;
                            }
                            board[minx][miny]++;
                        }
                    }
                }
            }
            board[x][y]=j;
        }
        for (i=0;i<max_islands;i++){
            x=Math.floor(islands[i]/H);
            y=islands[i]%H;
            cur_board[x][y]=board[x][y];
        }
    }
    for (i=0;i<W;i++) for (j=0;j<H;j++) if (cur_board[i][j]>0 && cur_board[i][j]<9){
        buttons[i][j].image="images/island"+cur_board[i][j]+".png";
        buttons[i][j].overImage="images/island"+cur_board[i][j]+"_over.png";
        buttons[i][j].downImage="images/island"+cur_board[i][j]+"_down.png";
        buttons[i][j].opacity=180;
    }else{
        buttons[i][j].image=buttons[i][j].overImage=buttons[i][j].downImage="images/b0.png";
        buttons[i][j].opacity=255;
    }
		for (i=0;i<W;i++) for (j=H;j<25;j++) buttons[i][j].image=buttons[i][j].overImage=buttons[i][j].downImage="images/b0.png";
		for (i=W;i<25;i++) for (j=0;j<25;j++) buttons[i][j].image=buttons[i][j].overImage=buttons[i][j].downImage="images/b0.png";
    cur_island=-1;
    block_input=false;
}
function setOpacity(island_nr){
    j=0;
    var x=Math.floor(islands[island_nr]/H);
    var y=islands[island_nr]%H;
    if (x>0 && (cur_board[x-1][y]==11 || cur_board[x-1][y]==12)) j+=cur_board[x-1][y]%10;
    if (x<W-1 && (cur_board[x+1][y]==11 || cur_board[x+1][y]==12)) j+=cur_board[x+1][y]%10;
    if (y>0 && (cur_board[x][y-1]==21 || cur_board[x][y-1]==22)) j+=cur_board[x][y-1]%10;
    if (y<H-1 && (cur_board[x][y+1]==21 || cur_board[x][y+1]==22)) j+=cur_board[x][y+1]%10;
    if (j==board[x][y]){
        buttons[x][y].opacity=255;
        return true;
    }else{
        buttons[x][y].opacity=160;
        return false;
    }
}
function isWon(){
	for (i=0;i<max_islands;i++) if (!setOpacity(i)) return false;
	var aux=new Array(max_islands);
	var da=true;
	var dir=0;
	aux[0]=true;
	for (i=1;i<max_islands;i++) aux[i]=false;
	while (da){
		da=false;
		for (i=0;i<max_islands;i++) if (aux[i]){
			for (dir=0;dir<4;dir++){
				var pasx=(dir==0?0:dir==1?1:dir==2?0:-1);
				var pasy=(dir==0?-1:dir==1?0:dir==2?1:0);
				var x=Math.floor(islands[i]/H);
				var y=islands[i]%H;
				if (x+pasx>=0 && x+pasx<W && y+pasy>=0 && y+pasy<H && ((dir%2==0 && cur_board[x+pasx][y+pasy]>20) || (dir%2==1 && cur_board[x+pasx][y+pasy]>10 && cur_board[x+pasx][y+pasy]<20))){
					x+=pasx;y+=pasy;
					while(cur_board[x][y]>10) {x+=pasx;y+=pasy;}
					j=0;x=x*H+y;
					while (islands[j]!=x) j++;
					if (!aux[j]) aux[j]=da=true;
				}
			}
		}
	}
	for (i=0;i<max_islands;i++) if (!aux[i]) return false;
	return true;    
}
function drawBoard(){
    for (i=0;i<W;i++) for (j=0;j<H;j++) if (cur_board[i][j]==0 || cur_board[i][j]>10) buttons[i][j].image=buttons[i][j].overImage=buttons[i][j].downImage="images/b"+cur_board[i][j]+".png";
}

//Event functions

function buttonClick(x,y){
    if (block_input || board[x][y]==0 || board[x][y]>8) {event.returnValue=false;return;}
    block_input=true;
    if (cur_island==x*H+y) {block_input=false;return;}
    if (cur_island>=0){
        var oldx=Math.floor(islands[cur_island]/H);
        var oldy=islands[cur_island]%H;
        buttons[oldx][oldy].image="images/island"+board[oldx][oldy]+".png";
        buttons[oldx][oldy].overImage="images/island"+board[oldx][oldy]+"_over.png";
    }
    var old_island=cur_island;
    cur_island=-1;
    for (i=0;i<max_islands && cur_island<0;i++) if (islands[i]==x*H+y) cur_island=i;
    if (cur_island<0) {cur_island=old_island;block_input=false;return;}
    buttons[x][y].image=buttons[x][y].overImage="images/island"+board[x][y]+"_down.png";
    if (old_island<0) {block_input=false;return;}
    if (x==oldx){
        for (i=Math.min(y,oldy)+1;i<Math.max(y,oldy);i++) if (cur_board[x][i]!=0 && cur_board[x][i]!=21 && cur_board[x][i]!=22) {block_input=false;return;}
        for (i=Math.min(y,oldy)+1;i<Math.max(y,oldy);i++) cur_board[x][i]=(cur_board[x][i]==0?21:cur_board[x][i]==21?22:0);
    }else if (y==oldy){
        for (i=Math.min(x,oldx)+1;i<Math.max(x,oldx);i++) if (cur_board[i][y]!=0 && cur_board[i][y]!=11 && cur_board[i][y]!=12) {block_input=false;return;}
        for (i=Math.min(x,oldx)+1;i<Math.max(x,oldx);i++) cur_board[i][y]=(cur_board[i][y]==0?11:cur_board[i][y]==11?12:0);
    }else{block_input=false;return;}
    setOpacity(cur_island);
    setOpacity(old_island);
    buttons[x][y].image="images/island"+board[x][y]+".png";
    buttons[x][y].overImage="images/island"+board[x][y]+"_over.png";
    cur_island=-1;
    drawBoard();
    if (isWon()){
        setTimeout('alert("Congratulations !!!\\nYou have won !!!\\nGood luck with your next challenge !!!\\n:-) !!!");newGame();',50);
        return;
    }
    block_input=false;
}
function Solve(){
    if (!confirm("Are you sure you want to give up ?")) return;
    for (i=0;i<W;i++) for (j=0;j<H;j++){
        cur_board[i][j]=board[i][j];
        buttons[i][j].opacity=255;
    }
    drawBoard();
    block_input=true;
    setTimeout('alert("There you go !\\nOne of the solutions to this puzzle !\\n - it might be the only one :-) - \\n\\nBetter luck solving the next one !");newGame();',50);
}

//Main program entry point

initializeVariables();
newGame();